(function() {
	//購入が未完了のアイテム
	var incompletePurchase;
	
	/*
	 * 課金済み情報を再取得
	 */
	function restorePurchase(productType) {
		applican.purchase.restorePurchase(productType, restorePurchaseSuccess, restorePurchaseError);
	}
	
	/*
	 * 課金済み情報を再取得成功時のcallback処理
	 * 	パラメータの属性：
	 * 		productId  : String	プロダクトID
	 * 		purchaseId : String	課金ID
	 * 		receipt    : String	課金認証用のレシート
	 * 		os         : String	プラットフォームのOS。"ios"又は"android"。
	 * 		isRestore  : String	購入済みアイテムのレストアかどうか（iOSのみ。Androidはfalse固定）
	 */
	function restorePurchaseSuccess(result) {
		incompletePurchase = new Array();
		var dump = "課金済み情報を再取得しました。\n";
		var resultCnt = result.length;
		if(resultCnt > 0) {
			for(var i = 0; i < resultCnt; i++) {
				var purchase = result[i];
				dump += "========================\n";
				dump += "productId : "  + purchase.productId  + "\n";
				dump += "isRestore : "  + purchase.isRestore  + "\n";
				dump += "purchaseId : " + purchase.purchaseId + "\n";
				dump += "receipt : "    + JSON.stringify(purchase.receipt)    + "\n";
				dump += "os : "         + purchase.os         + "\n";
				
				//購入が未完了のものをストック
				if((purchase.os === "ios" && !purchase.isRestore)
						|| (purchase.os === "android" && (purchase.productId === document.getElementById("inappChargeProductId").value))){
					dump += ">>>>productId:" + purchase.productId + "\n";
					incompletePurchase.push(purchase);
				}
			}
		}
		
		dump += "num : " + incompletePurchase.length + "\n";
		document.getElementById("dumpAreaPurchase").value = dump; 

		//購入が未完了のアイテムがある場合
		if(incompletePurchase.length > 0) {
			//購入が未完了のもの完了させる処理を呼ぶ
			repairPurchase();
		}
	}
	
	/*
	 * 課金済み情報を再取得失敗時のcallback処理
	 * 	パラメータの属性：
	 * 		code    : String	エラーコード
	 * 		message : String	エラーメッセージ
	 */
	function restorePurchaseError(error) {
		var dump = "課金済み情報の再取得に失敗しました。\n";
		dump    += "code:"    + error.code    + "\n";
		dump    += "message:" + error.message + "\n";
		document.getElementById("dumpAreaPurchase").value = dump; 
	}
	
	/*
	 * 購入が未完了のもの完了させる処理
	 */
	function repairPurchase() {
		if(incompletePurchase.length < 1) {
			var dump = "未完了決済の処理が完了しました。\n";
			document.getElementById("dumpAreaPurchase").value += dump;
			alert(dump);
			return;
		}

		document.getElementById("dumpAreaPurchase").value += "len:" + incompletePurchase.length + "\n";
		var purchase = incompletePurchase.shift();
		
		// ※productIdで判別して、課金アイテムの付与を行う
		applican.purchase.finishPurchase(purchase.purchaseId, repairPurchase, repairPurchaseError);
	}
	
	/*
	 * 決済完了できない時のcallback処理
	 * 	パラメータの属性：
	 * 		code    : String	エラーコード
	 * 		message : String	エラーメッセージ
	 */
	function repairPurchaseError(error) {
		alert("決済完了できませんでした。\n" + "code : " + error.code + "\n" + "message : " + error.message);
	}
	
	/*
	 * レストア(消費アイテム)
	 */
	restorePurchaseInapp = function(){
		restorePurchase("inapp");
	}
	
	/*
	 * レストア(定期購読アイテム)
	 */
	restorePurchaseSubs = function(){
		restorePurchase("subs");
	}
	
	/********************* イベント登録 *********************/
	document.addEventListener("deviceready", function() {
		// 「レストア」ボタン押下処理
		if(document.getElementById("restorePurchaseInappBtn")) {
			document.getElementById("restorePurchaseInappBtn").addEventListener("touchend", restorePurchaseInapp, false);
		}
		// 「定期購読レストア」ボタン押下処理
		if(document.getElementById("restorePurchaseSubsBtn")) {
			document.getElementById("restorePurchaseSubsBtn").addEventListener("touchend", restorePurchaseSubs, false);
		}
	}, false);
})();
